using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace SimpleSpline
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Sdgt.SdgManager sdgManager1;
		private SimpleSpline.ControlPoint controlPoint1;
		private SimpleSpline.ControlPoint controlPoint2;
		private SimpleSpline.ControlPoint controlPoint3;
		private SimpleSpline.ControlPoint controlPoint4;
		private System.ComponentModel.IContainer components;

		internal int[] DraggingObject;
		internal Point[] DraggingOffset;
		internal ArrayList ControlPoints;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			ControlPoints = new ArrayList();
			ControlPoints.Add((object) controlPoint1);
			ControlPoints.Add((object) controlPoint2);
			ControlPoints.Add((object) controlPoint3);
			ControlPoints.Add((object) controlPoint4);

			foreach (SimpleSpline.ControlPoint c in ControlPoints){
				c.SdgMouseDown += new Sdgt.SdgMouseEventHandler(c_SdgMouseDown);
				c.SdgMouseUp += new Sdgt.SdgMouseEventHandler(c_SdgMouseUp);
			}

			DraggingObject = new int[sdgManager1.Mice.Count];
			DraggingOffset = new Point[sdgManager1.Mice.Count];
			for (int i=0; i < sdgManager1.Mice.Count; ++i) {
				DraggingObject[i] = -1;
				DraggingOffset[i] = new Point(0,0);
			}

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.controlPoint1 = new SimpleSpline.ControlPoint();
			this.controlPoint2 = new SimpleSpline.ControlPoint();
			this.controlPoint3 = new SimpleSpline.ControlPoint();
			this.controlPoint4 = new SimpleSpline.ControlPoint();
			this.sdgManager1 = new Sdgt.SdgManager(this.components);
			this.SuspendLayout();
			// 
			// controlPoint1
			// 
			this.controlPoint1.CausesValidation = false;
			this.controlPoint1.Location = new System.Drawing.Point(160, 232);
			this.controlPoint1.Name = "controlPoint1";
			this.controlPoint1.Size = new System.Drawing.Size(8, 8);
			this.controlPoint1.TabIndex = 0;
			// 
			// controlPoint2
			// 
			this.controlPoint2.CausesValidation = false;
			this.controlPoint2.Location = new System.Drawing.Point(64, 112);
			this.controlPoint2.Name = "controlPoint2";
			this.controlPoint2.Size = new System.Drawing.Size(8, 8);
			this.controlPoint2.TabIndex = 1;
			// 
			// controlPoint3
			// 
			this.controlPoint3.CausesValidation = false;
			this.controlPoint3.Location = new System.Drawing.Point(160, 32);
			this.controlPoint3.Name = "controlPoint3";
			this.controlPoint3.Size = new System.Drawing.Size(8, 8);
			this.controlPoint3.TabIndex = 2;
			// 
			// controlPoint4
			// 
			this.controlPoint4.CausesValidation = false;
			this.controlPoint4.Location = new System.Drawing.Point(256, 136);
			this.controlPoint4.Name = "controlPoint4";
			this.controlPoint4.Size = new System.Drawing.Size(8, 8);
			this.controlPoint4.TabIndex = 3;
			// 
			// sdgManager1
			// 
			this.sdgManager1.EmulateSystemMouseMode = Sdgt.EmulateSystemMouseModes.Park;
			this.sdgManager1.Keyboards = null;
			this.sdgManager1.Mice = null;
			this.sdgManager1.MouseToFollow = 0;
			this.sdgManager1.ParkSystemMouseLocation = new System.Drawing.Point(350, 350);
			this.sdgManager1.RelativeTo = this;
			this.sdgManager1.MouseMove += new Sdgt.SdgMouseEventHandler(this.sdgManager1_MouseMove);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.controlPoint4);
			this.Controls.Add(this.controlPoint3);
			this.Controls.Add(this.controlPoint2);
			this.Controls.Add(this.controlPoint1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
			Pen p = new Pen(new SolidBrush(Color.Black), 2);
			e.Graphics.DrawBezier(p, controlPoint1.Location, controlPoint2.Location, controlPoint3.Location, controlPoint4.Location);
		}

		private void c_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e) {
			DraggingOffset[e.ID] = new Point(e.X, e.Y);
			for (int i=0; i < ControlPoints.Count; ++i) {
				if (sender == ControlPoints[i]) {
					DraggingObject[e.ID] = i;
				}
			}
		}

		private void c_SdgMouseUp(object sender, Sdgt.SdgMouseEventArgs e) {
			DraggingObject[e.ID] = -1;
		}

		private void sdgManager1_MouseMove(object sender, Sdgt.SdgMouseEventArgs e) {
			if (-1 != DraggingObject[e.ID]) {
				ControlPoint c = (ControlPoint) ControlPoints[DraggingObject[e.ID]];
				c.Location = new Point(e.X - DraggingOffset[e.ID].X, e.Y - DraggingOffset[e.ID].Y);
				this.Refresh();
			}
		}
	}
}
